Arch SplitMesh: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
Line 2: Line 2:
<translate>
<translate>
<!--T:11-->
<!--T:11-->
{{docnav
{{Docnav
|[[Arch_CloneComponent|Clone component]]
|[[Arch_CloneComponent|Clone component]]
|[[Arch_MeshToShape|Mesh To Shape]]
|[[Arch_MeshToShape|Mesh To Shape]]
Line 15: Line 15:
|Name=Arch SplitMesh
|Name=Arch SplitMesh
|MenuLocation=Arch → Utilities → Split Mesh
|MenuLocation=Arch → Utilities → Split Mesh
|Workbenches=[[Arch Module|Arch]]
|Workbenches=[[Arch_Module|Arch]]
|SeeAlso=[[Arch SelectNonSolidMeshes|Arch SelectNonSolidMeshes]], [[Arch MeshToShape|Arch MeshToShape]]
|SeeAlso=[[Arch_SelectNonSolidMeshes|Arch SelectNonSolidMeshes]], [[Arch_MeshToShape|Arch MeshToShape]]
}}
}}


Line 22: Line 22:


<!--T:3-->
<!--T:3-->
This tool splits a selected [[Mesh Module|Mesh]] object into its separate components
This tool splits a selected [[Mesh_Workbench|Mesh]] object into its separate components


==Usage== <!--T:4-->
==Usage== <!--T:4-->
Line 28: Line 28:
<!--T:5-->
<!--T:5-->
# Select a mesh object.
# Select a mesh object.
# Press the {{Button|[[Image:Arch_SplitMesh.svg|16px]] [[Arch SplitMesh|Split Mesh]]}} entry in {{MenuCommand|Arch → Utilities → Split Mesh}}.
# Press the {{Button|[[Image:Arch_SplitMesh.svg|16px]] [[Arch_SplitMesh|Split Mesh]]}} entry in {{MenuCommand|Arch → Utilities → Split Mesh}}.


==Scripting== <!--T:6-->
==Scripting== <!--T:6-->
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Arch_API|Arch API]] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].


<!--T:7-->
<!--T:7-->
Line 70: Line 70:


<!--T:13-->
<!--T:13-->
{{docnav
{{Docnav
|[[Arch_CloneComponent|Clone component]]
|[[Arch_CloneComponent|Clone component]]
|[[Arch_MeshToShape|Mesh To Shape]]
|[[Arch_MeshToShape|Mesh To Shape]]

Revision as of 20:02, 20 November 2020

Arch SplitMesh

Menu location
Arch → Utilities → Split Mesh
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch SelectNonSolidMeshes, Arch MeshToShape

Description

This tool splits a selected Mesh object into its separate components

Usage

  1. Select a mesh object.
  2. Press the Split Mesh entry in Arch → Utilities → Split Mesh.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The SplitMesh tool can be used in macros and from the Python console by using the following function:

new_list = splitMesh(obj, mark=True)
  • Splits the given mesh object (obj) into separated components.
  • If mark is True non-manifold components will be painted red.
  • new_list is a list of all the individual components that make the mesh.

Example:

import FreeCAD, Draft, Arch, Mesh, MeshPart

Line = Draft.makeWire([FreeCAD.Vector(0, 0, 0),FreeCAD.Vector(2000, 2000, 0)])
Wall = Arch.makeWall(Line, width=150, height=3000)
FreeCAD.ActiveDocument.recompute()

Shape = Wall.Shape.copy(False)
Shape.Placement = Wall.getGlobalPlacement()

mesh_obj = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
mesh_obj.Mesh = MeshPart.meshFromShape(Shape=Shape, MaxLength=520)
mesh_obj.ViewObject.DisplayMode = "Flat Lines"

new_list = Arch.splitMesh(mesh_obj)